diff --git a/sys/dev/drm/nouveau/core/include/core/object.h b/sys/dev/drm/nouveau/core/include/core/object.h
index d7039482d6..c9dd0448a5 100644
--- a/sys/dev/drm/nouveau/core/include/core/object.h
+++ b/sys/dev/drm/nouveau/core/include/core/object.h
@@ -140,7 +140,7 @@ static inline u8
 nv_ro08(void *obj, u64 addr)
 {
 	u8 data = nv_ofuncs(obj)->rd08(obj, addr);
-	nv_spam(obj, "nv_ro08 0x%08llx 0x%02x\n", addr, data);
+	nv_spam(obj, "nv_ro08 0x%08lx 0x%02x\n", addr, data);
 	return data;
 }
 
@@ -148,7 +148,7 @@ static inline u16
 nv_ro16(void *obj, u64 addr)
 {
 	u16 data = nv_ofuncs(obj)->rd16(obj, addr);
-	nv_spam(obj, "nv_ro16 0x%08llx 0x%04x\n", addr, data);
+	nv_spam(obj, "nv_ro16 0x%08lx 0x%04x\n", addr, data);
 	return data;
 }
 
@@ -156,28 +156,28 @@ static inline u32
 nv_ro32(void *obj, u64 addr)
 {
 	u32 data = nv_ofuncs(obj)->rd32(obj, addr);
-	nv_spam(obj, "nv_ro32 0x%08llx 0x%08x\n", addr, data);
+	nv_spam(obj, "nv_ro32 0x%08lx 0x%08x\n", addr, data);
 	return data;
 }
 
 static inline void
 nv_wo08(void *obj, u64 addr, u8 data)
 {
-	nv_spam(obj, "nv_wo08 0x%08llx 0x%02x\n", addr, data);
+	nv_spam(obj, "nv_wo08 0x%08lx 0x%02x\n", addr, data);
 	nv_ofuncs(obj)->wr08(obj, addr, data);
 }
 
 static inline void
 nv_wo16(void *obj, u64 addr, u16 data)
 {
-	nv_spam(obj, "nv_wo16 0x%08llx 0x%04x\n", addr, data);
+	nv_spam(obj, "nv_wo16 0x%08lx 0x%04x\n", addr, data);
 	nv_ofuncs(obj)->wr16(obj, addr, data);
 }
 
 static inline void
 nv_wo32(void *obj, u64 addr, u32 data)
 {
-	nv_spam(obj, "nv_wo32 0x%08llx 0x%08x\n", addr, data);
+	nv_spam(obj, "nv_wo32 0x%08lx 0x%08x\n", addr, data);
 	nv_ofuncs(obj)->wr32(obj, addr, data);
 }
 
diff --git a/sys/dev/drm/nouveau/core/include/core/subdev.h b/sys/dev/drm/nouveau/core/include/core/subdev.h
index e9632e9316..16d5d856c2 100644
--- a/sys/dev/drm/nouveau/core/include/core/subdev.h
+++ b/sys/dev/drm/nouveau/core/include/core/subdev.h
@@ -8,7 +8,7 @@
 
 struct nouveau_subdev {
 	struct nouveau_object base;
-	struct mutex mutex;
+	struct lock mutex;
 	const char *name;
 	void __iomem *mmio;
 	u32 debug;
diff --git a/sys/dev/drm/nouveau/core/include/engine/fifo.h b/sys/dev/drm/nouveau/core/include/engine/fifo.h
index e5e4d930b2..7cbbaf2e69 100644
--- a/sys/dev/drm/nouveau/core/include/engine/fifo.h
+++ b/sys/dev/drm/nouveau/core/include/engine/fifo.h
@@ -73,7 +73,7 @@ struct nouveau_fifo {
 	struct nvkm_event uevent; /* async user trigger */
 
 	struct nouveau_object **channel;
-	spinlock_t lock;
+	struct spinlock lock;
 	u16 min;
 	u16 max;
 
diff --git a/sys/dev/drm/nouveau/core/include/subdev/i2c.h b/sys/dev/drm/nouveau/core/include/subdev/i2c.h
index 1b937c2c25..9a6ee28d59 100644
--- a/sys/dev/drm/nouveau/core/include/subdev/i2c.h
+++ b/sys/dev/drm/nouveau/core/include/subdev/i2c.h
@@ -31,7 +31,7 @@ struct nvkm_i2c_ntfy_rep {
 struct nouveau_i2c_port {
 	struct nouveau_object base;
 	struct i2c_adapter adapter;
-	struct mutex mutex;
+	struct lock mutex;
 
 	struct list_head head;
 	u8  index;
@@ -95,12 +95,12 @@ nv_rdi2cr(struct nouveau_i2c_port *port, u8 addr, u8 reg)
 {
 	u8 val;
 	struct i2c_msg msgs[] = {
-		{ .addr = addr, .flags = 0, .len = 1, .buf = &reg },
-		{ .addr = addr, .flags = I2C_M_RD, .len = 1, .buf = &val },
+		{ .slave = addr << 1, .flags = 0, .len = 1, .buf = &reg },
+		{ .slave = addr << 1, .flags = I2C_M_RD, .len = 1, .buf = &val },
 	};
 
-	int ret = i2c_transfer(&port->adapter, msgs, 2);
-	if (ret != 2)
+	int ret = iicbus_transfer(&port->adapter, msgs, 2);
+	if (ret != 0)
 		return -EIO;
 
 	return val;
@@ -111,11 +111,11 @@ nv_wri2cr(struct nouveau_i2c_port *port, u8 addr, u8 reg, u8 val)
 {
 	u8 buf[2] = { reg, val };
 	struct i2c_msg msgs[] = {
-		{ .addr = addr, .flags = 0, .len = 2, .buf = buf },
+		{ .slave = addr << 1, .flags = 0, .len = 2, .buf = buf },
 	};
 
-	int ret = i2c_transfer(&port->adapter, msgs, 1);
-	if (ret != 1)
+	int ret = iicbus_transfer(&port->adapter, msgs, 1);
+	if (ret != 0)
 		return -EIO;
 
 	return 0;
diff --git a/sys/dev/drm/nouveau/core/os.h b/sys/dev/drm/nouveau/core/os.h
index ccfa21d72d..0cb9630990 100644
--- a/sys/dev/drm/nouveau/core/os.h
+++ b/sys/dev/drm/nouveau/core/os.h
@@ -1,6 +1,11 @@
 #ifndef __NOUVEAU_OS_H__
 #define __NOUVEAU_OS_H__
 
+#ifdef __DragonFly__
+#include <drm/drmP.h>
+#define CONFIG_NOUVEAU_DEBUG 0
+#define CONFIG_NOUVEAU_DEBUG_DEFAULT 0
+#endif
 #include <linux/types.h>
 #include <linux/slab.h>
 #include <linux/mutex.h>
@@ -14,7 +19,7 @@
 #include <linux/i2c-algo-bit.h>
 #include <linux/delay.h>
 #include <linux/io-mapping.h>
-#include <linux/acpi.h>
+#include <contrib/dev/acpica/source/include/acpi.h>
 #include <linux/vmalloc.h>
 #include <linux/dmi.h>
 #include <linux/reboot.h>
@@ -22,7 +27,9 @@
 #include <linux/log2.h>
 #include <linux/pm_runtime.h>
 #include <linux/power_supply.h>
+#ifndef __DragonFly__
 #include <linux/clk.h>
+#endif
 
 #include <asm/unaligned.h>
 
diff --git a/sys/dev/drm/nouveau/core/subdev/bar/nouveau_subdev_bar_base.c b/sys/dev/drm/nouveau/core/subdev/bar/nouveau_subdev_bar_base.c
index 8bcbdf39cf..92c2578a11 100644
--- a/sys/dev/drm/nouveau/core/subdev/bar/nouveau_subdev_bar_base.c
+++ b/sys/dev/drm/nouveau/core/subdev/bar/nouveau_subdev_bar_base.c
@@ -54,7 +54,7 @@ nouveau_barobj_ctor(struct nouveau_object *parent,
 	if (ret)
 		return ret;
 
-	barobj->iomem = bar->iomem + (u32)barobj->vma.offset;
+	barobj->iomem = (char *)bar->iomem + (u32)barobj->vma.offset;
 	return 0;
 }
 
diff --git a/sys/dev/drm/nouveau/core/subdev/bar/nouveau_subdev_bar_gk20a.c b/sys/dev/drm/nouveau/core/subdev/bar/nouveau_subdev_bar_gk20a.c
index bf877af9d3..8a9a175672 100644
--- a/sys/dev/drm/nouveau/core/subdev/bar/nouveau_subdev_bar_gk20a.c
+++ b/sys/dev/drm/nouveau/core/subdev/bar/nouveau_subdev_bar_gk20a.c
@@ -24,7 +24,7 @@
 
 #include "priv.h"
 
-int
+static int
 gk20a_bar_ctor(struct nouveau_object *parent, struct nouveau_object *engine,
 	       struct nouveau_oclass *oclass, void *data, u32 size,
 	       struct nouveau_object **pobject)
diff --git a/sys/dev/drm/nouveau/core/subdev/bar/nouveau_subdev_bar_nv50.c b/sys/dev/drm/nouveau/core/subdev/bar/nouveau_subdev_bar_nv50.c
index f748ba49df..e5e00da93e 100644
--- a/sys/dev/drm/nouveau/core/subdev/bar/nouveau_subdev_bar_nv50.c
+++ b/sys/dev/drm/nouveau/core/subdev/bar/nouveau_subdev_bar_nv50.c
@@ -32,7 +32,7 @@
 
 struct nv50_bar_priv {
 	struct nouveau_bar base;
-	spinlock_t lock;
+	struct spinlock lock;
 	struct nouveau_gpuobj *mem;
 	struct nouveau_gpuobj *pad;
 	struct nouveau_gpuobj *pgd;
diff --git a/sys/dev/drm/nouveau/core/subdev/bar/nouveau_subdev_bar_nvc0.c b/sys/dev/drm/nouveau/core/subdev/bar/nouveau_subdev_bar_nvc0.c
index 05a278bab2..c324e5cc8d 100644
--- a/sys/dev/drm/nouveau/core/subdev/bar/nouveau_subdev_bar_nvc0.c
+++ b/sys/dev/drm/nouveau/core/subdev/bar/nouveau_subdev_bar_nvc0.c
@@ -38,7 +38,7 @@ struct nvc0_bar_priv_vm {
 
 struct nvc0_bar_priv {
 	struct nouveau_bar base;
-	spinlock_t lock;
+	struct spinlock lock;
 	struct nvc0_bar_priv_vm bar[2];
 };
 
diff --git a/sys/dev/drm/nouveau/core/subdev/bios/nouveau_subdev_bios_base.c b/sys/dev/drm/nouveau/core/subdev/bios/nouveau_subdev_bios_base.c
index d45704a2c2..a8faaa7db9 100644
--- a/sys/dev/drm/nouveau/core/subdev/bios/nouveau_subdev_bios_base.c
+++ b/sys/dev/drm/nouveau/core/subdev/bios/nouveau_subdev_bios_base.c
@@ -74,7 +74,7 @@ nouveau_bios_shadow_of(struct nouveau_bios *bios)
 	data = of_get_property(dn, "NVDA,BMP", &size);
 	if (data && size) {
 		bios->size = size;
-		bios->data = kmalloc(bios->size, GFP_KERNEL);
+		bios->data = kmalloc(bios->size, M_DRM, GFP_KERNEL);
 		if (bios->data)
 			memcpy(bios->data, data, size);
 	}
@@ -127,7 +127,7 @@ nouveau_bios_shadow_pramin(struct nouveau_bios *bios)
 	if (!bios->size)
 		goto out;
 
-	bios->data = kmalloc(bios->size, GFP_KERNEL);
+	bios->data = kmalloc(bios->size, M_DRM, GFP_KERNEL);
 	if (bios->data) {
 		for (i = 0; i < bios->size; i++)
 			nv_wo08(bios, i, nv_rd08(bios, 0x700000 + i));
@@ -182,7 +182,7 @@ nouveau_bios_shadow_prom(struct nouveau_bios *bios)
 	if (!bios->size)
 		goto out;
 
-	bios->data = kmalloc(bios->size, GFP_KERNEL);
+	bios->data = kmalloc(bios->size, M_DRM, GFP_KERNEL);
 	if (!bios->data)
 		goto out;
 
@@ -231,7 +231,7 @@ nouveau_bios_shadow_acpi(struct nouveau_bios *bios)
 	}
 
 	bios->size = 0;
-	bios->data = kmalloc(4096, GFP_KERNEL);
+	bios->data = kmalloc(4096, M_DRM, GFP_KERNEL);
 	if (bios->data) {
 		if (nouveau_acpi_get_bios_chunk(bios->data, 0, 4096) == 4096)
 			bios->size = bios->data[2] * 512;
@@ -241,7 +241,7 @@ nouveau_bios_shadow_acpi(struct nouveau_bios *bios)
 	if (!bios->size)
 		return;
 
-	bios->data = kmalloc(bios->size, GFP_KERNEL);
+	bios->data = kmalloc(bios->size, M_DRM, GFP_KERNEL);
 	if (bios->data) {
 		/* disobey the acpi spec - much faster on at least w530 ... */
 		ret = nouveau_acpi_get_bios_chunk(bios->data, 0, bios->size);
@@ -267,7 +267,7 @@ nouveau_bios_shadow_pci(struct nouveau_bios *bios)
 	if (!pci_enable_rom(pdev)) {
 		void __iomem *rom = pci_map_rom(pdev, &size);
 		if (rom && size) {
-			bios->data = kmalloc(size, GFP_KERNEL);
+			bios->data = kmalloc(size, M_DRM, GFP_KERNEL);
 			if (bios->data) {
 				memcpy_fromio(bios->data, rom, size);
 				bios->size = size;
@@ -288,7 +288,7 @@ nouveau_bios_shadow_platform(struct nouveau_bios *bios)
 
 	void __iomem *rom = pci_platform_rom(pdev, &size);
 	if (rom && size) {
-		bios->data = kmalloc(size, GFP_KERNEL);
+		bios->data = kmalloc(size, M_DRM, GFP_KERNEL);
 		if (bios->data) {
 			memcpy_fromio(bios->data, rom, size);
 			bios->size = size;
@@ -364,10 +364,10 @@ nouveau_bios_shadow(struct nouveau_bios *bios)
 		} while ((++mthd)->shadow);
 
 		/* attempt to load firmware image */
-		ret = request_firmware(&fw, source, &nv_device(bios)->pdev->dev);
+		ret = request_firmware(&fw, source, nv_device(bios)->pdev->dev);
 		if (ret == 0) {
-			bios->size = fw->size;
-			bios->data = kmemdup(fw->data, fw->size, GFP_KERNEL);
+			bios->size = fw->datasize;
+			bios->data = kmemdup(fw->data, fw->datasize, GFP_KERNEL);
 			release_firmware(fw);
 
 			nv_info(bios, "image: %s\n", source);
diff --git a/sys/dev/drm/nouveau/core/subdev/bios/nouveau_subdev_bios_init.c b/sys/dev/drm/nouveau/core/subdev/bios/nouveau_subdev_bios_init.c
index 626380f9e4..d92525a260 100644
--- a/sys/dev/drm/nouveau/core/subdev/bios/nouveau_subdev_bios_init.c
+++ b/sys/dev/drm/nouveau/core/subdev/bios/nouveau_subdev_bios_init.c
@@ -1002,11 +1002,11 @@ init_zm_i2c(struct nvbios_init *init)
 	if (init_exec(init)) {
 		struct nouveau_i2c_port *port = init_i2c(init, index);
 		struct i2c_msg msg = {
-			.addr = addr, .flags = 0, .len = count, .buf = data,
+			.slave = addr << 1, .flags = 0, .len = count, .buf = data,
 		};
 		int ret;
 
-		if (port && (ret = i2c_transfer(&port->adapter, &msg, 1)) != 1)
+		if (port && (ret = iicbus_transfer(&port->adapter, &msg, 1)) != 0)
 			warn("i2c wr failed, %d\n", ret);
 	}
 }
@@ -2001,13 +2001,13 @@ init_i2c_long_if(struct nvbios_init *init)
 		u8 i[2] = { reghi, reglo };
 		u8 o[1] = {};
 		struct i2c_msg msg[] = {
-			{ .addr = addr, .flags = 0, .len = 2, .buf = i },
-			{ .addr = addr, .flags = I2C_M_RD, .len = 1, .buf = o }
+			{ .slave = addr << 1, .flags = 0, .len = 2, .buf = i },
+			{ .slave = addr << 1, .flags = I2C_M_RD, .len = 1, .buf = o }
 		};
 		int ret;
 
-		ret = i2c_transfer(&port->adapter, msg, 2);
-		if (ret == 2 && ((o[0] & mask) == data))
+		ret = iicbus_transfer(&port->adapter, msg, 2);
+		if (ret == 0 && ((o[0] & mask) == data))
 			return;
 	}
 
diff --git a/sys/dev/drm/nouveau/core/subdev/bus/nouveau_subdev_bus_hwsq.c b/sys/dev/drm/nouveau/core/subdev/bus/nouveau_subdev_bus_hwsq.c
index f757470e22..6ef18a42ba 100644
--- a/sys/dev/drm/nouveau/core/subdev/bus/nouveau_subdev_bus_hwsq.c
+++ b/sys/dev/drm/nouveau/core/subdev/bus/nouveau_subdev_bus_hwsq.c
@@ -47,7 +47,7 @@ nouveau_hwsq_init(struct nouveau_bus *pbus, struct nouveau_hwsq **phwsq)
 {
 	struct nouveau_hwsq *hwsq;
 
-	hwsq = *phwsq = kmalloc(sizeof(*hwsq), GFP_KERNEL);
+	hwsq = *phwsq = kmalloc(sizeof(*hwsq), M_DRM, GFP_KERNEL);
 	if (hwsq) {
 		hwsq->pbus = pbus;
 		hwsq->addr = ~0;
diff --git a/sys/dev/drm/nouveau/core/subdev/clock/nouveau_subdev_clock_base.c b/sys/dev/drm/nouveau/core/subdev/clock/nouveau_subdev_clock_base.c
index a276a71129..c49c5e1622 100644
--- a/sys/dev/drm/nouveau/core/subdev/clock/nouveau_subdev_clock_base.c
+++ b/sys/dev/drm/nouveau/core/subdev/clock/nouveau_subdev_clock_base.c
@@ -258,7 +258,7 @@ nouveau_pstate_info(struct nouveau_clock *clk, struct nouveau_pstate *pstate)
 	int i = -1;
 
 	if (pstate->pstate != 0xff)
-		snprintf(name, sizeof(name), "%02x", pstate->pstate);
+		ksnprintf(name, sizeof(name), "%02x", pstate->pstate);
 
 	while ((++clock)->name != nv_clk_src_max) {
 		u32 lo = pstate->base.domain[clock->name];
@@ -278,10 +278,10 @@ nouveau_pstate_info(struct nouveau_clock *clk, struct nouveau_pstate *pstate)
 			lo /= clock->mdiv;
 			hi /= clock->mdiv;
 			if (lo == hi) {
-				snprintf(info[i], sizeof(info[i]), "%s %d MHz",
+				ksnprintf(info[i], sizeof(info[i]), "%s %d MHz",
 					 clock->mname, lo);
 			} else {
-				snprintf(info[i], sizeof(info[i]),
+				ksnprintf(info[i], sizeof(info[i]),
 					 "%s %d-%d MHz", clock->mname, lo, hi);
 			}
 		}
@@ -405,13 +405,13 @@ nouveau_clock_nstate(struct nouveau_clock *clk, const char *mode, int arglen)
 		char save = mode[arglen];
 		long v;
 
-		((char *)mode)[arglen] = '\0';
+		(__DECONST(char *, mode))[arglen] = '\0';
 		if (!kstrtol(mode, 0, &v)) {
 			ret = nouveau_clock_ustate_update(clk, v);
 			if (ret < 0)
 				ret = 1;
 		}
-		((char *)mode)[arglen] = save;
+		(__DECONST(char *, mode))[arglen] = save;
 	}
 
 	return ret - 2;
diff --git a/sys/dev/drm/nouveau/core/subdev/clock/nouveau_subdev_clock_nv50.c b/sys/dev/drm/nouveau/core/subdev/clock/nouveau_subdev_clock_nv50.c
index 5070ebc260..61d7577373 100644
--- a/sys/dev/drm/nouveau/core/subdev/clock/nouveau_subdev_clock_nv50.c
+++ b/sys/dev/drm/nouveau/core/subdev/clock/nouveau_subdev_clock_nv50.c
@@ -54,7 +54,7 @@ read_pll_src(struct nv50_clock_priv *priv, u32 base)
 	struct nouveau_clock *clk = &priv->base;
 	u32 coef, ref = clk->read(clk, nv_clk_src_crystal);
 	u32 rsel = nv_rd32(priv, 0x00e18c);
-	int P, N, M, id;
+	int P, N, M, id = 0;
 
 	switch (nv_device(priv)->chipset) {
 	case 0x50:
diff --git a/sys/dev/drm/nouveau/core/subdev/fb/nouveau_subdev_fb_nv50.c b/sys/dev/drm/nouveau/core/subdev/fb/nouveau_subdev_fb_nv50.c
index 4150b0d10a..3fa911c46f 100644
--- a/sys/dev/drm/nouveau/core/subdev/fb/nouveau_subdev_fb_nv50.c
+++ b/sys/dev/drm/nouveau/core/subdev/fb/nouveau_subdev_fb_nv50.c
@@ -132,7 +132,7 @@ static const struct nouveau_enum vm_engine[] = {
 	{}
 };
 
-static const struct nouveau_enum vm_fault[] = {
+static const struct nouveau_enum _vm_fault[] = {
 	{ 0x00000000, "PT_NOT_PRESENT", NULL },
 	{ 0x00000001, "PT_TOO_SHORT", NULL },
 	{ 0x00000002, "PAGE_NOT_PRESENT", NULL },
@@ -227,7 +227,7 @@ nv50_fb_intr(struct nouveau_subdev *subdev)
 		pr_cont("%02x", st3);
 
 	pr_cont(" reason: ");
-	en = nouveau_enum_find(vm_fault, st1);
+	en = nouveau_enum_find(_vm_fault, st1);
 	if (en)
 		pr_cont("%s\n", en->name);
 	else
diff --git a/sys/dev/drm/nouveau/core/subdev/fb/nouveau_subdev_fb_ramgk20a.c b/sys/dev/drm/nouveau/core/subdev/fb/nouveau_subdev_fb_ramgk20a.c
index 4d77d75e46..6bc4865d60 100644
--- a/sys/dev/drm/nouveau/core/subdev/fb/nouveau_subdev_fb_ramgk20a.c
+++ b/sys/dev/drm/nouveau/core/subdev/fb/nouveau_subdev_fb_ramgk20a.c
@@ -59,7 +59,7 @@ gk20a_ram_get(struct nouveau_fb *pfb, u64 size, u32 align, u32 ncmin,
 	u32 npages, order;
 	int i;
 
-	nv_debug(pfb, "%s: size: %llx align: %x, ncmin: %x\n", __func__, size,
+	nv_debug(pfb, "%s: size: %lx align: %x, ncmin: %x\n", __func__, size,
 		 align, ncmin);
 
 	npages = size >> PAGE_SHIFT;
diff --git a/sys/dev/drm/nouveau/core/subdev/fb/nouveau_subdev_fb_ramnv1a.c b/sys/dev/drm/nouveau/core/subdev/fb/nouveau_subdev_fb_ramnv1a.c
index d0caddfb9d..8ad42a5022 100644
--- a/sys/dev/drm/nouveau/core/subdev/fb/nouveau_subdev_fb_ramnv1a.c
+++ b/sys/dev/drm/nouveau/core/subdev/fb/nouveau_subdev_fb_ramnv1a.c
@@ -31,12 +31,12 @@ nv1a_ram_create(struct nouveau_object *parent, struct nouveau_object *engine,
 {
 	struct nouveau_fb *pfb = nouveau_fb(parent);
 	struct nouveau_ram *ram;
-	struct pci_dev *bridge;
+	struct pci_dev bridge;
 	u32 mem, mib;
 	int ret;
 
-	bridge = pci_get_bus_and_slot(0, PCI_DEVFN(0, 1));
-	if (!bridge) {
+	bridge.dev = pci_find_dbsf(0, 0, 0, 0);
+	if (!bridge.dev) {
 		nv_fatal(pfb, "no bridge device\n");
 		return -ENODEV;
 	}
@@ -47,10 +47,10 @@ nv1a_ram_create(struct nouveau_object *parent, struct nouveau_object *engine,
 		return ret;
 
 	if (nv_device(pfb)->chipset == 0x1a) {
-		pci_read_config_dword(bridge, 0x7c, &mem);
+		pci_read_config_dword(&bridge, 0x7c, &mem);
 		mib = ((mem >> 6) & 31) + 1;
 	} else {
-		pci_read_config_dword(bridge, 0x84, &mem);
+		pci_read_config_dword(&bridge, 0x84, &mem);
 		mib = ((mem >> 4) & 127) + 1;
 	}
 
diff --git a/sys/dev/drm/nouveau/core/subdev/gpio/nouveau_subdev_gpio_nve0.c b/sys/dev/drm/nouveau/core/subdev/gpio/nouveau_subdev_gpio_nve0.c
index e1145b48c7..06842c473a 100644
--- a/sys/dev/drm/nouveau/core/subdev/gpio/nouveau_subdev_gpio_nve0.c
+++ b/sys/dev/drm/nouveau/core/subdev/gpio/nouveau_subdev_gpio_nve0.c
@@ -37,7 +37,7 @@ nve0_gpio_intr_stat(struct nouveau_gpio *gpio, u32 *hi, u32 *lo)
 	nv_wr32(gpio, 0x00dc80, intr1);
 }
 
-void
+static void
 nve0_gpio_intr_mask(struct nouveau_gpio *gpio, u32 type, u32 mask, u32 data)
 {
 	u32 inte0 = nv_rd32(gpio, 0x00dc08);
diff --git a/sys/dev/drm/nouveau/core/subdev/i2c/nouveau_subdev_i2c_anx9805.c b/sys/dev/drm/nouveau/core/subdev/i2c/nouveau_subdev_i2c_anx9805.c
index 2c2731a6cf..cdbadc0a39 100644
--- a/sys/dev/drm/nouveau/core/subdev/i2c/nouveau_subdev_i2c_anx9805.c
+++ b/sys/dev/drm/nouveau/core/subdev/i2c/nouveau_subdev_i2c_anx9805.c
@@ -184,8 +184,8 @@ anx9805_xfer(struct i2c_adapter *adap, struct i2c_msg *msgs, int num)
 	mdelay(5);
 
 	while (cnt--) {
-		if ( (msg->flags & I2C_M_RD) && msg->addr == 0x50) {
-			nv_wri2cr(mast, port->addr, 0x40, msg->addr << 1);
+		if ( (msg->flags & I2C_M_RD) && msg->slave == 0x50) {
+			nv_wri2cr(mast, port->addr, 0x40, msg->slave << 1);
 			nv_wri2cr(mast, port->addr, 0x41, seg);
 			nv_wri2cr(mast, port->addr, 0x42, off);
 			nv_wri2cr(mast, port->addr, 0x44, msg->len);
@@ -202,10 +202,10 @@ anx9805_xfer(struct i2c_adapter *adap, struct i2c_msg *msgs, int num)
 			}
 		} else
 		if (!(msg->flags & I2C_M_RD)) {
-			if (msg->addr == 0x50 && msg->len == 0x01) {
+			if (msg->slave == 0x50 && msg->len == 0x01) {
 				off = msg->buf[0];
 			} else
-			if (msg->addr == 0x30 && msg->len == 0x01) {
+			if (msg->slave == 0x30 && msg->len == 0x01) {
 				seg = msg->buf[0];
 			} else
 				goto done;
diff --git a/sys/dev/drm/nouveau/core/subdev/i2c/nouveau_subdev_i2c_aux.c b/sys/dev/drm/nouveau/core/subdev/i2c/nouveau_subdev_i2c_aux.c
index 02eb42be2e..3347ae5401 100644
--- a/sys/dev/drm/nouveau/core/subdev/i2c/nouveau_subdev_i2c_aux.c
+++ b/sys/dev/drm/nouveau/core/subdev/i2c/nouveau_subdev_i2c_aux.c
@@ -85,7 +85,7 @@ aux_xfer(struct i2c_adapter *adap, struct i2c_msg *msgs, int num)
 			if (mcnt || remaining > 16)
 				cmd |= 4; /* MOT */
 
-			ret = port->func->aux(port, true, cmd, msg->addr, ptr, cnt);
+			ret = port->func->aux(port, true, cmd, msg->slave, ptr, cnt);
 			if (ret < 0) {
 				i2c->release(port);
 				return ret;
diff --git a/sys/dev/drm/nouveau/core/subdev/i2c/nouveau_subdev_i2c_base.c b/sys/dev/drm/nouveau/core/subdev/i2c/nouveau_subdev_i2c_base.c
index a652cafde3..1718ef3761 100644
--- a/sys/dev/drm/nouveau/core/subdev/i2c/nouveau_subdev_i2c_base.c
+++ b/sys/dev/drm/nouveau/core/subdev/i2c/nouveau_subdev_i2c_base.c
@@ -126,7 +126,7 @@ nouveau_i2c_port_create_(struct nouveau_object *parent,
 	if (ret)
 		return ret;
 
-	snprintf(port->adapter.name, sizeof(port->adapter.name),
+	ksnprintf(port->adapter.name, sizeof(port->adapter.name),
 		 "nouveau-%s-%d", device->name, index);
 	port->adapter.owner = THIS_MODULE;
 	port->adapter.dev.parent = nv_device_base(device);
diff --git a/sys/dev/drm/nouveau/core/subdev/i2c/nouveau_subdev_i2c_nv94.c b/sys/dev/drm/nouveau/core/subdev/i2c/nouveau_subdev_i2c_nv94.c
index f59c3a2554..936279eb07 100644
--- a/sys/dev/drm/nouveau/core/subdev/i2c/nouveau_subdev_i2c_nv94.c
+++ b/sys/dev/drm/nouveau/core/subdev/i2c/nouveau_subdev_i2c_nv94.c
@@ -98,7 +98,7 @@ auxch_init(struct nouveau_i2c *aux, int ch)
 	return 0;
 }
 
-int
+static int
 nv94_aux(struct nouveau_i2c_port *base, bool retry,
 	 u8 type, u32 addr, u8 *data, u8 size)
 {
diff --git a/sys/dev/drm/nouveau/core/subdev/instmem/nouveau_subdev_instmem_nv50.c b/sys/dev/drm/nouveau/core/subdev/instmem/nouveau_subdev_instmem_nv50.c
index 7cb3b098a0..1821d54040 100644
--- a/sys/dev/drm/nouveau/core/subdev/instmem/nouveau_subdev_instmem_nv50.c
+++ b/sys/dev/drm/nouveau/core/subdev/instmem/nouveau_subdev_instmem_nv50.c
@@ -29,7 +29,7 @@
 
 struct nv50_instmem_priv {
 	struct nouveau_instmem base;
-	spinlock_t lock;
+	struct spinlock lock;
 	u64 addr;
 };
 
diff --git a/sys/dev/drm/nouveau/core/subdev/mc/nouveau_subdev_mc_base.c b/sys/dev/drm/nouveau/core/subdev/mc/nouveau_subdev_mc_base.c
index ca7cee3a31..1a40edce0c 100644
--- a/sys/dev/drm/nouveau/core/subdev/mc/nouveau_subdev_mc_base.c
+++ b/sys/dev/drm/nouveau/core/subdev/mc/nouveau_subdev_mc_base.c
@@ -74,7 +74,9 @@ nouveau_mc_intr(int irq, void *arg)
 	}
 
 	nv_wr32(pmc, 0x000140, 0x00000001);
-	return intr ? IRQ_HANDLED : IRQ_NONE;
+	if (intr)
+		return IRQ_HANDLED;
+	return IRQ_NONE;
 }
 
 int
diff --git a/sys/dev/drm/nouveau/core/subdev/mxm/nouveau_subdev_mxm_base.c b/sys/dev/drm/nouveau/core/subdev/mxm/nouveau_subdev_mxm_base.c
index 51fcf79604..0289d30c2c 100644
--- a/sys/dev/drm/nouveau/core/subdev/mxm/nouveau_subdev_mxm_base.c
+++ b/sys/dev/drm/nouveau/core/subdev/mxm/nouveau_subdev_mxm_base.c
@@ -36,11 +36,11 @@ mxm_shadow_rom_fetch(struct nouveau_i2c_port *i2c, u8 addr,
 		     u8 offset, u8 size, u8 *data)
 {
 	struct i2c_msg msgs[] = {
-		{ .addr = addr, .flags = 0, .len = 1, .buf = &offset },
-		{ .addr = addr, .flags = I2C_M_RD, .len = size, .buf = data, },
+		{ .slave = addr << 1, .flags = 0, .len = 1, .buf = &offset },
+		{ .slave = addr << 1, .flags = I2C_M_RD, .len = size, .buf = data, },
 	};
 
-	return i2c_transfer(&i2c->adapter, msgs, 2) == 2;
+	return iicbus_transfer(&i2c->adapter, msgs, 2) == 0;
 }
 
 static bool
@@ -66,7 +66,7 @@ mxm_shadow_rom(struct nouveau_mxm *mxm, u8 version)
 
 	mxm->mxms = mxms;
 	size = mxms_headerlen(mxm) + mxms_structlen(mxm);
-	mxm->mxms = kmalloc(size, GFP_KERNEL);
+	mxm->mxms = kmalloc(size, M_DRM, GFP_KERNEL);
 
 	if (mxm->mxms &&
 	    mxm_shadow_rom_fetch(port, addr, 0, size, mxm->mxms))
diff --git a/sys/dev/drm/nouveau/core/subdev/mxm/nouveau_subdev_mxm_nv50.c b/sys/dev/drm/nouveau/core/subdev/mxm/nouveau_subdev_mxm_nv50.c
index fcaabe8456..bf2519e78a 100644
--- a/sys/dev/drm/nouveau/core/subdev/mxm/nouveau_subdev_mxm_nv50.c
+++ b/sys/dev/drm/nouveau/core/subdev/mxm/nouveau_subdev_mxm_nv50.c
@@ -184,7 +184,7 @@ mxm_show_unmatched(struct nouveau_mxm *mxm, u8 *data, void *info)
 {
 	u64 desc = *(u64 *)data;
 	if ((desc & 0xf0) != 0xf0)
-	nv_info(mxm, "unmatched output device 0x%016llx\n", desc);
+	nv_info(mxm, "unmatched output device 0x%016lx\n", desc);
 	return true;
 }
 
diff --git a/sys/dev/drm/nouveau/core/subdev/therm/nouveau_subdev_therm_fantog.c b/sys/dev/drm/nouveau/core/subdev/therm/nouveau_subdev_therm_fantog.c
index f69dab11f7..32c6c53151 100644
--- a/sys/dev/drm/nouveau/core/subdev/therm/nouveau_subdev_therm_fantog.c
+++ b/sys/dev/drm/nouveau/core/subdev/therm/nouveau_subdev_therm_fantog.c
@@ -33,7 +33,7 @@
 struct nouveau_fantog_priv {
 	struct nouveau_fan base;
 	struct nouveau_alarm alarm;
-	spinlock_t lock;
+	struct spinlock lock;
 	u32 period_us;
 	u32 percent;
 	struct dcb_gpio_func func;
diff --git a/sys/dev/drm/nouveau/core/subdev/therm/nouveau_subdev_therm_temp.c b/sys/dev/drm/nouveau/core/subdev/therm/nouveau_subdev_therm_temp.c
index 6212537b90..b9036e1ea5 100644
--- a/sys/dev/drm/nouveau/core/subdev/therm/nouveau_subdev_therm_temp.c
+++ b/sys/dev/drm/nouveau/core/subdev/therm/nouveau_subdev_therm_temp.c
@@ -129,7 +129,7 @@ void nouveau_therm_sensor_event(struct nouveau_therm *therm,
 		if (active) {
 			struct work_struct *work;
 
-			work = kmalloc(sizeof(*work), GFP_ATOMIC);
+			work = kmalloc(sizeof(*work), M_DRM, GFP_ATOMIC);
 			if (work) {
 				INIT_WORK(work, nv_poweroff_work);
 				schedule_work(work);
diff --git a/sys/dev/drm/nouveau/core/subdev/therm/priv.h b/sys/dev/drm/nouveau/core/subdev/therm/priv.h
index 916fca5c78..ceffd7fc26 100644
--- a/sys/dev/drm/nouveau/core/subdev/therm/priv.h
+++ b/sys/dev/drm/nouveau/core/subdev/therm/priv.h
@@ -41,7 +41,7 @@ struct nouveau_fan {
 	struct nvbios_perf_fan perf;
 
 	struct nouveau_alarm alarm;
-	spinlock_t lock;
+	struct spinlock lock;
 	int percent;
 
 	int (*get)(struct nouveau_therm *therm);
@@ -73,7 +73,7 @@ struct nouveau_therm_priv {
 
 	/* automatic thermal management */
 	struct nouveau_alarm alarm;
-	spinlock_t lock;
+	struct spinlock lock;
 	struct nouveau_therm_trip_point *last_trip;
 	int mode;
 	int cstate;
@@ -87,7 +87,7 @@ struct nouveau_therm_priv {
 
 	/* alarms priv */
 	struct {
-		spinlock_t alarm_program_lock;
+		struct spinlock alarm_program_lock;
 		struct nouveau_alarm therm_poll_alarm;
 		enum nouveau_therm_thrs_state alarm_state[NOUVEAU_THERM_THRS_NR];
 		void (*program_alarms)(struct nouveau_therm *);
diff --git a/sys/dev/drm/nouveau/core/subdev/timer/nouveau_subdev_timer_nv04.c b/sys/dev/drm/nouveau/core/subdev/timer/nouveau_subdev_timer_nv04.c
index 240ed0b983..86b6bd0086 100644
--- a/sys/dev/drm/nouveau/core/subdev/timer/nouveau_subdev_timer_nv04.c
+++ b/sys/dev/drm/nouveau/core/subdev/timer/nouveau_subdev_timer_nv04.c
@@ -44,7 +44,7 @@ nv04_timer_alarm_trigger(struct nouveau_timer *ptimer)
 	struct nv04_timer_priv *priv = (void *)ptimer;
 	struct nouveau_alarm *alarm, *atemp;
 	unsigned long flags;
-	LIST_HEAD(exec);
+	LINUX_LIST_HEAD(exec);
 
 	/* move any due alarms off the pending list */
 	spin_lock_irqsave(&priv->lock, flags);
diff --git a/sys/dev/drm/nouveau/core/subdev/timer/nv04.h b/sys/dev/drm/nouveau/core/subdev/timer/nv04.h
index 4bc152697c..03a7c3962e 100644
--- a/sys/dev/drm/nouveau/core/subdev/timer/nv04.h
+++ b/sys/dev/drm/nouveau/core/subdev/timer/nv04.h
@@ -14,7 +14,7 @@
 struct nv04_timer_priv {
 	struct nouveau_timer base;
 	struct list_head alarms;
-	spinlock_t lock;
+	struct spinlock lock;
 	u64 suspend_time;
 };
 
diff --git a/sys/dev/drm/nouveau/core/subdev/vm/nouveau_subdev_vm_nv41.c b/sys/dev/drm/nouveau/core/subdev/vm/nouveau_subdev_vm_nv41.c
index 064c762628..18578b4131 100644
--- a/sys/dev/drm/nouveau/core/subdev/vm/nouveau_subdev_vm_nv41.c
+++ b/sys/dev/drm/nouveau/core/subdev/vm/nouveau_subdev_vm_nv41.c
@@ -92,7 +92,7 @@ nv41_vmmgr_ctor(struct nouveau_object *parent, struct nouveau_object *engine,
 	struct nv04_vmmgr_priv *priv;
 	int ret;
 
-	if (pci_find_capability(device->pdev, PCI_CAP_ID_AGP) ||
+	if (pci_find_extcap(device->pdev->dev, PCIY_AGP, NULL) == 0 ||
 	    !nouveau_boolopt(device->cfgopt, "NvPCIE", true)) {
 		return nouveau_object_ctor(parent, engine, &nv04_vmmgr_oclass,
 					   data, size, pobject);
diff --git a/sys/dev/drm/nouveau/core/subdev/vm/nouveau_subdev_vm_nv44.c b/sys/dev/drm/nouveau/core/subdev/vm/nouveau_subdev_vm_nv44.c
index fae1f67d59..1238d3cc6c 100644
--- a/sys/dev/drm/nouveau/core/subdev/vm/nouveau_subdev_vm_nv44.c
+++ b/sys/dev/drm/nouveau/core/subdev/vm/nouveau_subdev_vm_nv44.c
@@ -163,7 +163,7 @@ nv44_vmmgr_ctor(struct nouveau_object *parent, struct nouveau_object *engine,
 	struct nv04_vmmgr_priv *priv;
 	int ret;
 
-	if (pci_find_capability(device->pdev, PCI_CAP_ID_AGP) ||
+	if (pci_find_extcap(device->pdev->dev, PCIY_AGP, NULL) == 0 ||
 	    !nouveau_boolopt(device->cfgopt, "NvPCIE", true)) {
 		return nouveau_object_ctor(parent, engine, &nv04_vmmgr_oclass,
 					   data, size, pobject);
diff --git a/sys/dev/drm/nouveau/dispnv04/nouveau_dispnv04_cursor.c b/sys/dev/drm/nouveau/dispnv04/nouveau_dispnv04_cursor.c
index 4e61173c33..59429e0453 100644
--- a/sys/dev/drm/nouveau/dispnv04/nouveau_dispnv04_cursor.c
+++ b/sys/dev/drm/nouveau/dispnv04/nouveau_dispnv04_cursor.c
@@ -1,5 +1,9 @@
 #include <drm/drmP.h>
+#ifdef __DragonFly__
+#include <uapi_drm/drm_mode.h>
+#else
 #include <drm/drm_mode.h>
+#endif
 #include "nouveau_drm.h"
 #include "nouveau_reg.h"
 #include "nouveau_crtc.h"
diff --git a/sys/dev/drm/nouveau/dispnv04/nouveau_dispnv04_hw.c b/sys/dev/drm/nouveau/dispnv04/nouveau_dispnv04_hw.c
index 3d4c193007..561192636b 100644
--- a/sys/dev/drm/nouveau/dispnv04/nouveau_dispnv04_hw.c
+++ b/sys/dev/drm/nouveau/dispnv04/nouveau_dispnv04_hw.c
@@ -362,7 +362,7 @@ nouveau_hw_save_vga_fonts(struct drm_device *dev, bool save)
 		NVBlankScreen(dev, 1, false);
 	NVBlankScreen(dev, 0, false);
 
-	iounmap(iovram);
+	iounmap(iovram, 65536);
 }
 
 /*
diff --git a/sys/dev/drm/nouveau/dispnv04/nouveau_dispnv04_overlay.c b/sys/dev/drm/nouveau/dispnv04/nouveau_dispnv04_overlay.c
index b36afcbbc8..0cb6434d6f 100644
--- a/sys/dev/drm/nouveau/dispnv04/nouveau_dispnv04_overlay.c
+++ b/sys/dev/drm/nouveau/dispnv04/nouveau_dispnv04_overlay.c
@@ -25,7 +25,11 @@
 
 #include <drm/drmP.h>
 #include <drm/drm_crtc.h>
+#ifdef __DragonFly__
+#include <uapi_drm/drm_fourcc.h>
+#else
 #include <drm/drm_fourcc.h>
+#endif
 
 #include "nouveau_drm.h"
 
diff --git a/sys/dev/drm/nouveau/nouveau_abi16.c b/sys/dev/drm/nouveau/nouveau_abi16.c
index 615714c172..34732482d5 100644
--- a/sys/dev/drm/nouveau/nouveau_abi16.c
+++ b/sys/dev/drm/nouveau/nouveau_abi16.c
@@ -188,10 +188,10 @@ nouveau_abi16_ioctl_getparam(ABI16_IOCTL_ARGS)
 		if (!nv_device_is_pci(nvkm_device(device)))
 			getparam->value = 3;
 		else
-		if (drm_pci_device_is_agp(dev))
+		if (drm_device_is_agp(dev))
 			getparam->value = 0;
 		else
-		if (!pci_is_pcie(dev->pdev))
+		if (!drm_device_is_pcie(dev))
 			getparam->value = 1;
 		else
 			getparam->value = 2;
@@ -218,7 +218,7 @@ nouveau_abi16_ioctl_getparam(ABI16_IOCTL_ARGS)
 		getparam->value = graph->units ? graph->units(graph) : 0;
 		break;
 	default:
-		NV_PRINTK(debug, cli, "unknown parameter %lld\n", getparam->param);
+		NV_PRINTK(debug, cli, "unknown parameter %lu\n", getparam->param);
 		return -EINVAL;
 	}
 
diff --git a/sys/dev/drm/nouveau/nouveau_acpi.c b/sys/dev/drm/nouveau/nouveau_acpi.c
index 622424692b..7f15040e50 100644
--- a/sys/dev/drm/nouveau/nouveau_acpi.c
+++ b/sys/dev/drm/nouveau/nouveau_acpi.c
@@ -1,5 +1,5 @@
 #include <linux/pci.h>
-#include <linux/acpi.h>
+#include <contrib/dev/acpica/source/include/acpi.h>
 #include <linux/slab.h>
 #include <linux/mxm-wmi.h>
 #include <linux/vga_switcheroo.h>
diff --git a/sys/dev/drm/nouveau/nouveau_agp.c b/sys/dev/drm/nouveau/nouveau_agp.c
index 1f6f6ba684..542ce74fde 100644
--- a/sys/dev/drm/nouveau/nouveau_agp.c
+++ b/sys/dev/drm/nouveau/nouveau_agp.c
@@ -73,7 +73,7 @@ nouveau_agp_enabled(struct nouveau_drm *drm)
 {
 	struct drm_device *dev = drm->dev;
 
-	if (!dev->pdev || !drm_pci_device_is_agp(dev) || !dev->agp)
+	if (!dev->pdev || !drm_device_is_agp(dev) || !dev->agp)
 		return false;
 
 	if (drm->agp.stat == UNKNOWN) {
diff --git a/sys/dev/drm/nouveau/nouveau_bios.h b/sys/dev/drm/nouveau/nouveau_bios.h
index 0067586eb0..d982e38fe3 100644
--- a/sys/dev/drm/nouveau/nouveau_bios.h
+++ b/sys/dev/drm/nouveau/nouveau_bios.h
@@ -92,7 +92,7 @@ struct nvbios {
 	uint8_t digital_min_front_porch;
 	bool fp_no_ddc;
 
-	spinlock_t lock;
+	struct spinlock lock;
 
 	bool execute;
 
